regina::NSurfaceFilterCombination Class Reference
Normal Surfaces

A normal surface filter that simply combines other filters. More...

`#include <surfaces/sfcombination.h>`

Inheritance diagram for regina::NSurfaceFilterCombination:

## Public Member Functions

| NSurfaceFilterCombination ()
| Creates a new surface filter that accepts all normal surfaces. More...
| NSurfaceFilterCombination (const NSurfaceFilterCombination &cloneMe)
| Creates a new surface filter that is a clone of the given surface filter. More...
bool | getUsesAnd () const
| Determines whether this is an and or an or combination. More...
void | setUsesAnd (bool value)
| Sets whether this is an and or an or combination. More...
virtual bool | accept (const NNormalSurface &surface) const
| Decides whether or not the given normal surface is accepted by this filter. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::NSurfaceFilter
| NSurfaceFilter ()
| Creates a new default surface filter. More...
| NSurfaceFilter (const NSurfaceFilter &cloneMe)
| Creates a new default surface filter. More...
virtual | ~NSurfaceFilter ()
| Destroys this surface filter. More...
virtual SurfaceFilterType | getFilterType () const
| Returns the unique integer ID corresponding to the filtering method that is this particular subclass of NSurfaceFilter. More...
virtual SurfaceFilterType | getFilterID () const
| A deprecated alias for getFilterType(). More...
virtual std::string | getFilterTypeName () const
| Returns a string description of the filtering method that is this particular subclass of NSurfaceFilter. More...
virtual std::string | getFilterName () const
| A deprecated alias for getFilterTypeName(). More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual bool | dependsOnParent () const
| Determines if this packet depends upon its parent. More...
Public Member Functions inherited from regina::NPacket
| NPacket (NPacket *parent=0)
| Constructor that inserts the new packet into the overall tree structure. More...
virtual | ~NPacket ()
| Destructor that also orphans this packet and destroys all of its descendants. More...
virtual PacketType | getPacketType () const =0
| Returns the unique integer ID representing this type of packet. More...
virtual std::string | getPacketTypeName () const =0
| Returns an English name for this type of packet. More...
const std::string & | getPacketLabel () const
| Returns the label associated with this individual packet. More...
std::string | getHumanLabel () const
| Returns the label associated with this individual packet, adjusted if necessary for human-readable output. More...
void | setPacketLabel (const std::string &newLabel)
| Sets the label associated with this individual packet. More...
std::string | getFullName () const
| Returns a descriptive text string for the packet. More...
std::string | makeUniqueLabel (const std::string &base) const
| Returns a new label that cannot be found anywhere in the entire tree structure. More...
bool | makeUniqueLabels (NPacket *reference)
| Ensures that all packet labels in both this and the given packet tree combined are distinct. More...
bool | hasTag (const std::string &tag) const
| Determines whether this packet has the given associated tag. More...
bool | hasTags () const
| Determines whether this packet has any associated tags at all. More...
bool | addTag (const std::string &tag)
| Associates the given tag with this packet. More...
bool | removeTag (const std::string &tag)
| Removes the association of the given tag with this packet. More...
void | removeAllTags ()
| Removes all associated tags from this packet. More...
const std::set< std::string > & | getTags () const
| Returns the set of all tags associated with this packet. More...
bool | listen (NPacketListener *listener)
| Registers the given packet listener to listen for events on this packet. More...
bool | isListening (NPacketListener *listener)
| Determines whether the given packet listener is currently listening for events on this packet. More...
bool | unlisten (NPacketListener *listener)
| Unregisters the given packet listener so that it no longer listens for events on this packet. More...
NPacket * | getTreeParent () const
| Determines the parent packet in the tree structure. More...
NPacket * | getFirstTreeChild () const
| Determines the first child of this packet in the tree structure. More...
NPacket * | getLastTreeChild () const
| Determines the last child of this packet in the tree structure. More...
NPacket * | getNextTreeSibling () const
| Determines the next sibling of this packet in the tree structure. More...
NPacket * | getPrevTreeSibling () const
| Determines the previous sibling of this packet in the tree structure. More...
NPacket * | getTreeMatriarch () const
| Determines the matriarch (the root) of the tree to which this packet belongs. More...
unsigned | levelsDownTo (const NPacket *descendant) const
| Counts the number of levels between this packet and its given descendant in the tree structure. More...
unsigned | levelsUpTo (const NPacket *ancestor) const
| Counts the number of levels between this packet and its given ancestor in the tree structure. More...
bool | isGrandparentOf (const NPacket *descendant) const
| Determines if this packet is equal to or an ancestor of the given packet in the tree structure. More...
unsigned long | getNumberOfChildren () const
| Returns the number of immediate children of this packet. More...
unsigned long | getNumberOfDescendants () const
| Returns the total number of descendants of this packet. More...
unsigned long | getTotalTreeSize () const
| Determines the total number of packets in the tree or subtree for which this packet is matriarch. More...
void | insertChildFirst (NPacket *child)
| Inserts the given packet as the first child of this packet. More...
void | insertChildLast (NPacket *child)
| Inserts the given packet as the last child of this packet. More...
void | insertChildAfter (NPacket *newChild, NPacket *prevChild)
| Inserts the given packet as a child of this packet at the given location in this packet's child list. More...
void | makeOrphan ()
| Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree. More...
void | reparent (NPacket *newParent, bool first=false)
| Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead. More...
void | swapWithNextSibling ()
| Swaps this packet with its next sibling in the sequence of children beneath their common parent packet. More...
void | moveUp (unsigned steps=1)
| Moves this packet the given number of steps towards the beginning of its sibling list. More...
void | moveDown (unsigned steps=1)
| Moves this packet the given number of steps towards the end of its sibling list. More...
void | moveToFirst ()
| Moves this packet to be the first in its sibling list. More...
void | moveToLast ()
| Moves this packet to be the last in its sibling list. More...
void | sortChildren ()
| Sorts the immediate children of this packet according to their packet labels. More...
NPacket * | nextTreePacket ()
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
const NPacket * | nextTreePacket () const
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
NPacket * | firstTreePacket (const std::string &type)
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
const NPacket * | firstTreePacket (const std::string &type) const
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
NPacket * | nextTreePacket (const std::string &type)
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
const NPacket * | nextTreePacket (const std::string &type) const
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
NPacket * | findPacketLabel (const std::string &label)
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
const NPacket * | findPacketLabel (const std::string &label) const
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
bool | isPacketEditable () const
| Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children. More...
NPacket * | clone (bool cloneDescendants=false, bool end=true) const
| Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet. More...
void | writeXMLFile (std::ostream &out) const
| Writes a complete XML file containing the subtree with this packet as matriarch. More...
std::string | internalID () const
| Returns a unique string ID that identifies this packet. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NXMLFilterReader * | getXMLFilterReader (NPacket *parent)
Static Public Member Functions inherited from regina::NSurfaceFilter
static NXMLFilterReader * | getXMLFilterReader (NPacket *parent)
| Returns a newly created XML filter reader that will read the details of a particular type of surface filter. More...
static NXMLPacketReader * | getXMLReader (NPacket *parent, NXMLTreeResolver &resolver)
Static Public Member Functions inherited from regina::NPacket
static NXMLPacketReader * | getXMLReader (NPacket *parent, NXMLTreeResolver &resolver)
| Returns a newly created XML element reader that will read the contents of a single XML packet element. More...

## Protected Member Functions

virtual NPacket * | internalClonePacket (NPacket *parent) const
| Makes a newly allocated copy of this packet. More...
virtual void | writeXMLFilterData (std::ostream &out) const
| Writes a chunk of XML containing the details of this filter. More...
Protected Member Functions inherited from regina::NSurfaceFilter
virtual void | writeXMLPacketData (std::ostream &out) const
| Writes a chunk of XML containing the data for this packet only. More...
Protected Member Functions inherited from regina::NPacket
void | writeXMLPacketTree (std::ostream &out) const
| Writes a chunk of XML containing the subtree with this packet as matriarch. More...
Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Additional Inherited Members

Public Types inherited from regina::NPacket
typedef ChangeEventSpan | ChangeEventBlock
| A deprecated typedef for ChangeEventSpan. More...

## Detailed Description

A normal surface filter that simply combines other filters.

This filter will combine, using boolean and or or, all of the filters that are immediate children of this packet. This packet may have children that are not normal surface filters; such children will simply be ignored.

If there are no immediate child filters, a normal surface will be accepted if this is an and filter and rejected if this is an or filter.

## Constructor & Destructor Documentation

regina::NSurfaceFilterCombination::NSurfaceFilterCombination | ( |  | ) |

inline

Creates a new surface filter that accepts all normal surfaces.

This will be an and filter.

regina::NSurfaceFilterCombination::NSurfaceFilterCombination | ( | const NSurfaceFilterCombination & | cloneMe | ) |

inline

Creates a new surface filter that is a clone of the given surface filter.

Parameters

  cloneMe | the surface filter to clone.

## Member Function Documentation

virtual bool regina::NSurfaceFilterCombination::accept | ( | const NNormalSurface & | surface | ) | const

virtual

Decides whether or not the given normal surface is accepted by this filter.

The default implementation simply returns `true`.

Parameters

  surface | the normal surface under investigation.

Returns
  `true` if and only if the given surface is accepted by this filter.

Reimplemented from regina::NSurfaceFilter.

bool regina::NSurfaceFilterCombination::getUsesAnd | ( |  | ) | const

inline

Determines whether this is an and or an or combination.

Returns
  `true` if this is an and combination, or `false` if this is an or combination.

NPacket * regina::NSurfaceFilterCombination::internalClonePacket | ( | NPacket * | parent | ) | const

inline protected virtual

Makes a newly allocated copy of this packet.

This routine should not insert the new packet into the tree structure, clone the packet's associated tags or give the packet a label. It should also not clone any descendants of this packet.

You may assume that the new packet will eventually be inserted into the tree beneath either the same parent as this packet or a clone of that parent.

Parameters

  parent | the parent beneath which the new packet will eventually be inserted.

Returns
  the newly allocated packet.

Reimplemented from regina::NSurfaceFilter.

void regina::NSurfaceFilterCombination::setUsesAnd | ( | bool | value | ) |

inline

Sets whether this is an and or an or combination.

Parameters

  value | `true` if this is to be an and combination, or `false` if this is to be an or combination.

void regina::NSurfaceFilterCombination::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

virtual void regina::NSurfaceFilterCombination::writeXMLFilterData | ( | std::ostream & | out | ) | const

protected virtual

Writes a chunk of XML containing the details of this filter.

You may assume that the filter opening tag (including the filter type) has already been written, and that the filter closing tag will be written immediately after this routine is called. This routine need only write the additional details corresponding to this particular subclass of NSurfaceFilter.

Parameters

  out | the output stream to which the XML should be written.

Reimplemented from regina::NSurfaceFilter.

The documentation for this class was generated from the following file:

- surfaces/sfcombination.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).